 /* 433MHz Sniffer fr Alecto WSD17 Wetterstation (pearl) und fr ELRO DIP Funkschaltsteckdosen, 
 * adapted from(c) 2017 by wend
 * adaoted by fsg4u 2018
 */


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <bcm2835.h>
int strpos(char *haystack, char *needle, int offset);

#define PIN 27 /* GPIO 27 */
 
#define MAXTIMING 256  /*Maximale Telegrammlaenge*/

int timing[MAXTIMING];
int tcount=0;

int verbose=0;

char result[MAXTIMING];
char result2[12]; //used for temperature value data
char result3[12]; //used for humidity value tenth data
char result4[12]; //used for humidity value single data

extern long long int *timer;
void init_timer();
static int atobin(char *n) {
  int value=0;
  while(*n) {
    value<<=1;
    if(*n!='0') value++;  
    n++;
  }
  return(value);
}

//decode single bits into bitorder
int decode_generic(char *ptr) {
  int i;
  int sum;

  for(i=0;i<tcount-1;i+=2) {
    sum=timing[i+1]+timing[i+2];
    if(sum>4300 && sum<4500)        *ptr++='1'; //temperature sensor value high
    else if(sum>2300 && sum<2500)   *ptr++='0'; //temperature sensor value low
    else if(sum>1100 && sum<1300) {
        if(timing[i+1]>4*sum/8) *ptr++='1';	//remote value high
	else                    *ptr++='0';	//remote value low
    }  
}
*ptr=0;

}


//checks if the ID is at correct position or shifted 
//if not correct and not shifted then return value is -1
int strpos(char *hay, char *needle, int offset)
{
   char haystack[strlen(hay)];
   strncpy(haystack, hay+offset, strlen(hay)-offset);
   char *p = strstr(haystack, needle);
   if (p)
      return p - haystack+offset;
   return -1;
}


void printout() {
  int i,protocol=0;
  int sum;
  int mint=100000;
  
  if(tcount>0) {
    if(timing[0]>9000 && timing[0]<9900){ //that should be our timing
    	decode_generic(result);
    	if ((strlen(result)==36) || (strlen(result)==35)) { //could be temperature
    		char *id="01001000";
		int pos = strpos(result,id, 0)+2;
		if (pos!=1){
     			for(i=0;i<12;i++) {
				result2[i]=result[i+12+pos];
     			}
     			result2[12]='\0';
     			result2[13]='\0';
     			double temp=atobin(result2);
     			temp =temp/10;
     			if(temp>100) temp=temp - 409.0;
      			//try humidity
      			for(i=0;i<4;i++) {
				result3[i]=result[i+24+pos];
        			result4[i]=result[i+28+pos];
      			}
      			int hum = atobin(result3) + atobin(result4)*10 ;
			printf("Temperature: %0.1lfC Humidity: %d \n",temp,hum);
      			//printf("temp: %s Temperature: %0.1lfC Humidity: %d \n",result2,temp,hum);
     		}
		else{ 
			printf("Incorrect ID\n");
			printf("%s\n",result);		
		}	
    	}
    	else if (strlen(result)==24){ //could be remote
    		if (strlen(result)==24) printf("remote: %d\n",atobin(result));
    	}
	else printf("Length: %d Result: %s\n",strlen(result),result);
    }     
  }
}

int main(int argc, char *argv[]) {
  struct timespec tim, tim2;
  long long int ot,st;
  
  int a,oa;
  int state=0;
  int bcnt=0;
  int count=0;
  int oc;
  
  if(!bcm2835_init()) return 1;
  tim.tv_sec = 0;
  tim.tv_nsec = 100;

  // Set the pin to be an input
  bcm2835_gpio_fsel(PIN, BCM2835_GPIO_FSEL_INPT);
  init_timer();

  st=ot=*timer;
  while(1) {
    a=bcm2835_gpio_lev(PIN);
      if(a!=oa) {
        timing[tcount]=(int)(*timer-ot);
        ot=*timer;
        oc=count;
        if(a && (timing[tcount]>9000)) {	  
          if(tcount>10) printout();
          timing[0]=timing[tcount];
          tcount=1;
          state=1;
        } else if (state==1 && timing[tcount]<5) {
  	  a=!a;
        } else if (state==1 && timing[tcount]<100) {
          if(tcount>10) printout();
  	  state=0;
        } else if(state==1) {
          tcount++;
          if(tcount>=MAXTIMING-1) state=0;
        } 
        oa=a;
      }    
      count++;
  }
  return 0;
}
